local n=require"luci.util"
local l=require"nixio.fs"
local t=require"luci.jsonc"
local c=require"luci.ini"
local s=os
local d=io
local i=table
local e=string
local u=tonumber
local a=print
local a=type
local r=assert
local m=pairs
local o=ipairs
local h=tostring
local h=getmetatable
local f=require("luci.model.uci").cursor()
module"luci.model.mmdvm"
MMDVMHOST_CONFFILE="/etc/MMDVM.ini"
YSFGATEWAY_CONFFILE="/etc/YSFGateway.ini"
P25GATEWAY_CONFFILE="/etc/P25Gateway.ini"
NXDNGATEWAY_CONFFILE="/etc/NXDNGateway.ini"
DAPNETGATEWAY_CONFFILE="/etc/DAPNETGateway.ini"
IRCDDBGATEWAY_CONFFILE="/etc/ircddbgateway"
UCI_CONFFILE="/etc/config/mmdvm"
function pocsag_enabled()
return f:get('mmdvm','POCSAG','Enable')=='1'
and l.access("/etc/init.d/dapnetgateway")
end
function ini_load(e)
r(a(e)=='string','Parameter "fileName" must be a string.')
return c.parse(e)
end
function ini_save(t,e)
r(a(t)=='string','Parameter "fileName" must be a string.')
r(a(e)=='table','Parameter "data" must be a table.')
c.save(t,e)
end
function ini2uci(e)
local n={
General={"Callsign","Id","Duplex","NetModeHang","RFModeHang"},
Info={"RXFrequency","TXFrequency","Latitude","Longitude","Power","Height","Location","Description","URL"},
Modem={"Port","RXOffset","TXOffset","RSSIMappingFile"},
DMR={"Enable","ColorCode","SelfOnly","DumpTAData"},
DMR_Network={"Address","Password"},
System_Fusion={"Enable","SelfOnly"},
System_Fusion_Network={"Enable"},
P25={"Enable","NAC","SelfOnly","OverrideUIDCheck"},
P25_Network={"Enable"},
NXDN={"Enable"},
NXDN_Network={"Enable"},
POCSAG={"Enable","Frequency"},
POCSAG_Network={"Enable"},
DStar={"Enable","Module"},
DStar_Network={"Enable"}
}
local a=false
local s=ini_load(MMDVMHOST_CONFFILE)
local d=ini_load(YSFGATEWAY_CONFFILE)
local r=ini_load(P25GATEWAY_CONFFILE)
local u=ini_load(NXDNGATEWAY_CONFFILE)
local i=l.stat(UCI_CONFFILE,"mtime")
local l=h(s).__inifile.mtime
local c=h(d).__inifile.mtime
local f=h(r).__inifile.mtime
local w=h(u).__inifile.mtime
for n,r in m(n)do
local h=(n:gsub("_"," ")):gsub("DStar","D-Star")
if s[h]then
for r,o in o(r)do
if not e:get("mmdvm",n,o)or l>i then
local o={[o]=s[h][o]}
e:section("mmdvm","mmdvmhost",n,o)
log(("init %s/mmdvmhost/%s/%s"):format(UCI_CONFFILE,n,t.stringify(o)))
a=true
end
end
end
end
local l="Network"
local n="YSFG_Network"
local s={"Startup","InactivityTimeout","Revert"}
for s,o in o(s)do
if not e:get("mmdvm",n,o)or c>i then
local o={[o]=d[l][o]}
e:section("mmdvm","ysfgateway",n,o)
log(("init %s/ysfgateway/%s/%s"):format(UCI_CONFFILE,n,t.stringify(o)))
a=true
end
end
local s="Network"
local n="P25G_Network"
local d={"Startup","InactivityTimeout","Revert"}
for h,o in o(d)do
if not e:get("mmdvm",n,o)or f>i then
local o={[o]=r[s][o]}
e:section("mmdvm","p25gateway",n,o)
log(("init %s/p25gateway/%s/%s"):format(UCI_CONFFILE,n,t.stringify(o)))
a=true
end
end
local r="Network"
local n="NXDNG_Network"
local s={"Startup","InactivityTimeout","Revert"}
for s,o in o(s)do
if not e:get("mmdvm",n,o)or w>i then
local o={[o]=u[r][o]}
e:section("mmdvm","nxdngateway",n,o)
log(("init %s/nxdngateway/%s/%s"):format(UCI_CONFFILE,n,t.stringify(o)))
a=true
end
end
if file_exists(DAPNETGATEWAY_CONFFILE)and file_exists("/etc/init.d/dapnetgateway")then
local s=ini_load(DAPNETGATEWAY_CONFFILE)
local r=h(s).__inifile.mtime
local n={
DAPNET_General={section="General",options={"Callsign"}},
DAPNET_DAPNET={section="DAPNET",options={"Address","AuthKey"}},
}
for n,h in m(n)do
for d,o in o(h.options)do
if not e:get("mmdvm",n,o)or r>i then
local o={[o]=s[h.section][o]}
e:section("mmdvm","dapnetgateway",n,o)
log(("init %s/dapnetgateway/%s/%s"):format(UCI_CONFFILE,n,t.stringify(o)))
a=true
end
end
end
end
if file_exists(IRCDDBGATEWAY_CONFFILE)and file_exists("/etc/init.d/ircddbgateway")then
local s=ini_load(IRCDDBGATEWAY_CONFFILE)
local h=h(s).__inifile.mtime
local r="default"
local n="ircddbgateway"
local d={"gatewayCallsign","repeaterCall1","reflector1","ircddbUsername","dplusLogin","aprsHostname"}
for d,o in o(d)do
if not e:get("mmdvm",n,o)or h>i then
local o={[o]=s[r][o]}
e:section("mmdvm","dstar",n,o)
log(("init %s/ircddbgateway/%s/%s"):format(UCI_CONFFILE,n,t.stringify(o)))
a=true
end
end
end
if a then
e:save("mmdvm")
e:commit("mmdvm")
end
end
function uci2ini(h)
local s=false
for e,o in o(h)do
local n=o[1]
local e=(o[2]:gsub("_"," ")):gsub("DStar","D-Star")
local a=o[3]
local i=o[4]
if n=="set"then
if e:find("YSFG ")then
local n=e:sub(6)
local e=ini_load(YSFGATEWAY_CONFFILE)
if e[n]and e[n][a]then
e[n][a]=i
ini_save(YSFGATEWAY_CONFFILE,e)
log("YSFGateway.ini update - "..t.stringify(o))
end
elseif e:find("P25G ")then
local n=e:sub(6)
local e=ini_load(P25GATEWAY_CONFFILE)
if e[n]and e[n][a]then
e[n][a]=i
ini_save(P25GATEWAY_CONFFILE,e)
log("P25Gateway.ini update - "..t.stringify(o))
end
elseif e:find("NXDNG ")then
local n=e:sub(7)
local e=ini_load(NXDNGATEWAY_CONFFILE)
if e[n]and e[n][a]then
e[n][a]=i
ini_save(NXDNGATEWAY_CONFFILE,e)
log("NXDNGateway.ini update - "..t.stringify(o))
end
elseif e:find("DAPNET ")and file_exists(DAPNETGATEWAY_CONFFILE)and file_exists("/etc/init.d/dapnetgateway")then
local n=e:sub(8)
local e=ini_load(DAPNETGATEWAY_CONFFILE)
if e[n]and e[n][a]then
e[n][a]=i
ini_save(DAPNETGATEWAY_CONFFILE,e)
log("DAPNETGateway.ini update - "..t.stringify(o))
end
elseif e=="ircddbgateway"then
local e=ini_load(IRCDDBGATEWAY_CONFFILE)
if e["default"][a]then
e["default"][a]=i
ini_save(IRCDDBGATEWAY_CONFFILE,e)
log("ircddbgateway update - "..t.stringify(o))
end
else
local n=ini_load(MMDVMHOST_CONFFILE)
if n[e]and n[e][a]then
n[e][a]=i
ini_save(MMDVMHOST_CONFFILE,n)
log("MMDVM.ini update - "..t.stringify(o))
end
s=true
end
end
end
log(t.stringify(h))
return s
end
function s2t(t)
local a=e.sub(t,1,4)
local o=e.sub(t,6,7)
local i=e.sub(t,9,10)
local n=e.sub(t,12,13)
local h=e.sub(t,15,16)
local e=e.sub(t,18,19)
return s.time({day=i,month=o,year=a,hour=n,min=h,sec=e})
end
function file_exists(e)
return l.access(e)
end
function get_bm_list()
local e="/etc/mmdvm/BMMasters.txt"
local e=r(d.open(e,'r'),'Error loading file : '..e)
local t={}
for e in e:lines()do
local e=e:split(",")
i.insert(t,{e[1],e[2],e[4]})
end
return t
end
function get_ysf_list()
local e="/etc/mmdvm/YSFHosts.txt"
local t=r(d.open(e,'r'),'Error loading file : '..e)
local e={}
for t in t:lines()do
local t=t:split(";")
i.insert(e,{t[1],t[2]})
end
return e
end
local function t(e)
local e=r(d.open(e,'r'),'Error loading file : '..e)
local t={}
for e in e:lines()do
if e:trim()~=""and e:byte(1)~=35 then
local e=e:split("%s+",nil,true)
i.insert(t,{e[1],e[2]})
end
end
return t
end
function get_p25_list()
local a="/etc/mmdvm/P25Hosts.txt"
local e="/etc/mmdvm/P25Hosts_private.txt"
local a=t(a)
for t,e in o(t(e))do
i.insert(a,{e[1],e[2].." - private"})
end
return a
end
function get_nxdn_list()
local e="/etc/mmdvm/NXDNHosts.txt"
local a="/etc/mmdvm/NXDNHosts_private.txt"
local e=t(e)
for a,t in o(t(a))do
i.insert(e,{t[1],t[2].." - private"})
end
return e
end
function log(e)
e=("mmdvm: %s"):format(e)
n.ubus("log","write",{event=e})
end
function get_mmdvm_log()
local e=""
local t={}
local a="/var/log/mmdvm/MMDVM-%s.log"%{s.date("%Y-%m-%d")}
if file_exists(a)then
e=n.trim(n.exec("tail -n250 %s | egrep -h \"from|end|watchdog|lost\""%{a}))
t=e:split("\n")
end
if#t<20 then
a="/var/log/mmdvm/MMDVM-%s.log"%{s.date("%Y-%m-%d",s.time()-24*60*60)}
if file_exists(a)then
e=e.."\n"..n.trim(n.exec("tail -n250 %s | egrep -h \"from|end|watchdog|lost\""%{a}))
t=e:split("\n")
end
end
i.sort(t,function(e,t)return e>t end)
return t
end
function get_dapnet_log()
local a=""
local e={}
local t="/var/log/mmdvm/DAPNETGateway-%s.log"%{s.date("%Y-%m-%d")}
if file_exists(t)then
a=n.trim(n.exec("tail -n250 %s | egrep -h \"Sending message\""%{t}))
e=a:split("\n")
end
if#e<20 then
t="/var/log/mmdvm/DAPNETGateway-%s.log"%{s.date("%Y-%m-%d",s.time()-24*60*60)}
if file_exists(t)then
a=a.."\n"..n.trim(n.exec("tail -n250 %s | egrep -h \"Sending message\""%{t}))
e=a:split("\n")
end
end
i.sort(e,function(e,t)return e>t end)
return e
end
local function c(t)
local l={}
local s,n,r,c
for a=1,#t do
local t=t[a]
repeat
if e.find(t,"BS_Dwn_Act")or
e.find(t,"invalid access")or
e.find(t,"received RF header for wrong repeater")or
e.find(t,"Error returned")or
e.find(t,"unable to decode the network CSBK")or
e.find(t,"overflow in the DMR slot RF queue")or
e.find(t,"non repeater RF header received")or
e.find(t,"Embedded Talker Alias")or
e.find(t,"DMR Talker Alias")or
e.find(t,"CSBK Preamble")or
e.find(t,"Preamble CSBK")or
e.find(t,"Preamble VSBK")or
e.find(t,"Downlink Activate received")or
e.find(t,"Received a NAK")or
e.find(t,"0000")
then
break
end
local d=e.sub(t,28,(e.find(t,",")or 0)-1)
if e.find(t,"end of")
or e.find(t,"watchdog has expired")
or e.find(t,"ended RF data")
or e.find(t,"ended network")
or e.find(t,"RF user has timed out")
or e.find(t,"transmission lost")
or e.find(t,"D-Star")
or e.find(t,"POCSAG")
then
local a=t:split(", ")
local o=(a and#a)or 0
if e.find(t,"RF user has timed out")then
s="-1"
r="-1"
else
if o>=3 then
s=e.trim(e.sub(a[3],1,e.find(a[3]," ")))
end
if o>=4 then
n=a[4]
end
end
if e.find(n or"","BER")==1 then
r=e.trim(e.sub(n,6,8))
n="0"
else
n=e.trim(e.sub(n or"",1,-14))
if o>=5 then
r=e.trim(e.sub(a[5]or"",6,-2))
end
end
end
local m=e.sub(t,4,22)
local o,a
local h="RF"
if d~='POCSAG'then
if e.find(t,"from")and e.find(t,"to")then
o=e.gsub(e.trim(e.sub(t,e.find(t,"from")+5,e.find(t,"to")-2))," ","")
a=e.sub(t,e.find(t,"to")+3)
a=e.gsub(e.trim(e.sub(a,0,e.find(a,","))),",","")
end
if e.find(t,"network")then
h="Net"
end
end
local e={
["DMR Slot 1"]=function()
if e.find(t,"ended RF data")or e.find(t,"ended network")then
s="SMS"
end
end,
["DMR Slot 2"]=function()
if e.find(t,"ended RF data")or e.find(t,"ended network")then
s="SMS"
end
end,
["YSF"]=function()
if a and a:find('at')then
a=e.trim(e.sub(a,14))
end
end,
["P25"]=function()
if h=="Net"then
if a=="TG 10"then
o="PARROT"
end
if o=="10999"then
o="MMDVM"
end
end
end,
["NXDN"]=function()
if h=="Net"then
if a=="TG 10"then
o="PARROT"
end
end
end,
["D-Star"]=function()
end,
["POCSAG"]=function()
o='DAPNET'
h="Net"
a='ALL'
s='0.0'
n='0'
r='0.0'
end,
}
local e=e[d]
if(e)then e()end
if o and#o:trim()<=11 then
i.insert(l,
{
timestamp=m,
mode=d,
callsign=o,
target=a,
source=h,
duration=s,
loss=u(n)or 0,
ber=u(r)or 0,
rssi=c
}
)
end
until true
end
return l
end
function get_lastheard()
local n={}
local o={}
local e=get_mmdvm_log()
local e=c(e)
for t=1,#e,1 do
local a=e[t].callsign.."@"..e[t].mode
if o[a]==nil then
o[a]=true
i.insert(n,e[t])
end
end
return n
end
function get_last_pocsag()
local a={}
local e=get_dapnet_log()
for e,t in o(e)do
local e=t:split(", ")
local o=(e and#e)or 0
if o<3 then break end
local n,h,s,r
n=t:sub(4,22)
if o>=3 then
local e=e[1]:split(" ")
h=e[8]
s=e[10]
local e=t:split('"')
r=e[2]
end
i.insert(a,{
timestamp=n,
timeslot=h,
target=s,
message=r
})
if#a>20 then break end
end
return a
end